// override.cpp - LCTextOut
#include "override.h"
#pragma comment(lib, "Gdi32.lib")
#pragma comment(lib, "User32.lib")


#if 1
inline void  TRACE(LPWSTR msg) {}
inline void  PerformanceCheckStart() {}
inline void  PerformanceCheck(LPCWSTR msg) {}
#else
#include <stdio.h>
static unsigned __int64  g_timeFreq = 0;
static unsigned __int64  g_timePoint = 0;

inline void  TRACE(LPWSTR msg) {
	OutputDebugString(msg);
}
void  PerformanceCheckStart() {
	if(g_timeFreq == 0)
		QueryPerformanceFrequency((LARGE_INTEGER*)&g_timeFreq);
	QueryPerformanceCounter((LARGE_INTEGER*)&g_timePoint);
	TRACE(L"---");
}
void  PerformanceCheck(LPCWSTR msg) {
	unsigned __int64  old = g_timePoint;
	QueryPerformanceCounter((LARGE_INTEGER*)&g_timePoint);
	WCHAR str[256];
	_snwprintf(str, 256, L"performance(%s) %.3f usec", msg, ((double)g_timePoint - (double)old) / ((double)g_timeFreq / 1000000.0));
	TRACE(str);
}
#endif


// bNAbve[u(255*9=2295)
BYTE ColorTable3x[2296];
UINT Quality, Weight, UseSubPixel, SubPixelDirection;

// kɎgp郋bNAbve[u
void InitColorTable(void){
	int i;
	// 0`2295܂ł̒l9Ŋ̂LbV
	for(i = 0; i < 2296; i++) ColorTable3x[i] = i / 9;
}
// INIt@Cǂݍ
void LoadSettings(HMODULE hModule){
	WCHAR szFileName[MAX_PATH + 1] = L"";
	// DLL̃tpX擾
	GetModuleFileName(hModule, szFileName, MAX_PATH);
	// gq".ini"ɒu
	lstrcpy(szFileName + lstrlen(szFileName) - 3, L"ini");
	// eݒǂݍ
	// INIt@C̗:
	// [General]
	// Quality=1
	// Weight=0
	// UseSubPixel=0
	// SubPixelDirection=0
	Quality = GetPrivateProfileInt(L"General",L"Quality",2,szFileName);
	Weight = GetPrivateProfileInt(L"General",L"Weight",0,szFileName);
	UseSubPixel = GetPrivateProfileInt(L"General",L"UseSubPixel",0,szFileName);
	SubPixelDirection = GetPrivateProfileInt(L"General",L"SubPixelDirection",0,szFileName);
}



/*
DWORD WINAPI IMPL_GetTabbedTextExtentA(HDC hdc, LPCSTR lpString, int nCount, int nTabPositions, CONST LPINT lpnTabStopPositions)
{
	TRACE(L"GetTabbedTextExtentA");
	DWORD b = ORIG_GetTabbedTextExtentA(hdc, lpString, nCount, nTabPositions, lpnTabStopPositions);
	TRACE(L"GetTabbedTextExtentA END");
	return b;
}
DWORD WINAPI IMPL_GetTabbedTextExtentW(HDC hdc, LPCWSTR lpString, int nCount, int nTabPositions, CONST LPINT lpnTabStopPositions)
{
	TRACE(L"GetTabbedTextExtentW");
	DWORD b = ORIG_GetTabbedTextExtentW(hdc, lpString, nCount, nTabPositions, lpnTabStopPositions);
	TRACE(L"GetTabbedTextExtentW END");
	return b;
}
BOOL WINAPI IMPL_GetTextExtentExPointA(HDC hdc, LPCSTR lpszStr, int cchString, int nMaxExtent, LPINT lpnFit, LPINT lpDx, LPSIZE lpSize)
{
	TRACE(L"GetTextExtentExPointA");
	BOOL b = ORIG_GetTextExtentExPointA(hdc, lpszStr, cchString, nMaxExtent, lpnFit, lpDx, lpSize);
	TRACE(L"GetTextExtentExPointA END");
	return b;
}
BOOL WINAPI IMPL_GetTextExtentExPointW(HDC hdc, LPCWSTR lpszStr, int cchString, int nMaxExtent, LPINT lpnFit, LPINT lpDx, LPSIZE lpSize)
{
	TRACE(L"GetTextExtentExPointW");
	BOOL b = ORIG_GetTextExtentExPointW(hdc, lpszStr, cchString, nMaxExtent, lpnFit, lpDx, lpSize);
	TRACE(L"GetTextExtentExPointW END");
	return b;
}
BOOL WINAPI IMPL_GetTextExtentExPointI(HDC hdc, LPWORD pgiIn, int cgi, int nMaxExtent, LPINT lpnFit, LPINT lpDx, LPSIZE lpSize)
{
	TRACE(L"GetTextExtentExPointI");
	BOOL b = ORIG_GetTextExtentExPointI(hdc, pgiIn, cgi, nMaxExtent, lpnFit, lpDx, lpSize);
	TRACE(L"GetTextExtentExPointI END");
	return b;
}
BOOL WINAPI IMPL_GetTextExtentPointA(HDC hdc, LPCSTR lpString, int cbString, LPSIZE lpSize)
{
	TRACE(L"GetTextExtentPointA");
	BOOL b = ORIG_GetTextExtentPointA(hdc, lpString, cbString, lpSize);
	TRACE(L"GetTextExtentPointA END");
	return b;
}
BOOL WINAPI IMPL_GetTextExtentPointW(HDC hdc, LPCWSTR lpString, int cbString, LPSIZE lpSize)
{
	TRACE(L"GetTextExtentPointW");
	BOOL b = ORIG_GetTextExtentPointW(hdc, lpString, cbString, lpSize);
	TRACE(L"GetTextExtentPointW END");
	return b;
}
BOOL WINAPI IMPL_GetTextExtentPointI(HDC hdc, LPWORD pgiIn, int cgi, LPSIZE lpSize)
{
	TRACE(L"GetTextExtentPointI");
	BOOL b = ORIG_GetTextExtentPointI(hdc, pgiIn, cgi, lpSize);
	TRACE(L"GetTextExtentPointI END");
	return b;
}
BOOL WINAPI IMPL_GetTextExtentPoint32A(HDC hdc, LPCSTR lpString, int cbString, LPSIZE lpSize)
{
	TRACE(L"GetTextExtentPoint32A");
	BOOL b = ORIG_GetTextExtentPoint32A(hdc, lpString, cbString, lpSize);
	TRACE(L"GetTextExtentPoint32A END");
	return b;
}
*/



// mȃTCYԂGetTextExtentPoint32̎
BOOL WINAPI IMPL_GetTextExtentPoint32W(HDC hdc, LPCWSTR lpString, int cbString, LPSIZE lpSize)
{
//#if 0
//	TRACE(L"GetTextExtentPoint32W");
//	BOOL b = ORIG_GetTextExtentPoint32W(hdc, lpString, cbString, lpSize);
//	TRACE(L"GetTextExtentPoint32W END");
//	return b;
//#else
	int TextExtra;
	TEXTMETRIC fontMetric;
	HDC hCanvasDC;
	HFONT hSrcFont, hCanvasFont;
	LOGFONT logCanvasFont;
	SIZE sizeString;

	// Quality=0ȂoCpX
	if (Quality==0) return ORIG_GetTextExtentPoint32W(hdc,lpString,cbString,lpSize);

	// DC쐬
	hCanvasDC = CreateCompatibleDC(hdc);
	// `LOGFONT擾
	hSrcFont = (HFONT)SelectObject(hdc, GetStockObject(SYSTEM_FONT));
	GetObject(hSrcFont, sizeof(logCanvasFont), &logCanvasFont);
	SelectObject(hdc, hSrcFont);
	// tHgTCY2{/3{/4{ɂ
	switch(Quality){
	case 2:
		logCanvasFont.lfHeight *=  3;
		break;
	case 3:
		logCanvasFont.lfHeight <<= 2;
		break;
	default:
		logCanvasFont.lfHeight <<= 1;
	}
	logCanvasFont.lfQuality = ANTIALIASED_QUALITY;
	hCanvasFont = CreateFontIndirect(&logCanvasFont);
	SelectObject(hCanvasDC, hCanvasFont);

	// Ԃݒ肳Ă邩Ȃ̂ŐݒRs[
	TextExtra = GetTextCharacterExtra(hdc);
	if (TextExtra!=0x8000000) {
		switch(Quality){
		case 2:
			SetTextCharacterExtra(hCanvasDC, TextExtra * 3);
			break;
		case 3:
			SetTextCharacterExtra(hCanvasDC, TextExtra << 2);
			break;
		default:
			SetTextCharacterExtra(hCanvasDC, TextExtra << 1);
		}
	}
	// `悳镶̑傫擾
	ORIG_GetTextExtentPoint32W(hCanvasDC,lpString,cbString, &sizeString);

	// Α̎ɑ镶l
	//GetTextMetrics(hCanvasDC, &fontMetric);
	//sizeString.cx += fontMetric.tmOverhang;

	// iɉ2/3/4̔{ɂ낦
	switch(Quality){
	case 2:
		if ((sizeString.cx % 3) != 0) sizeString.cx += (3 - (sizeString.cx % 3));
		if ((sizeString.cy % 3) != 0) sizeString.cy += (3 - (sizeString.cy % 3));
		lpSize->cx = sizeString.cx / 3;
		lpSize->cy = sizeString.cy / 3;
		break;
	case 3:
		if ((sizeString.cx % 4) != 0) sizeString.cx += (4 - (sizeString.cx % 4));
		if ((sizeString.cy % 4) != 0) sizeString.cy += (4 - (sizeString.cy % 4));
		lpSize->cx = sizeString.cx >> 2;
		lpSize->cy = sizeString.cy >> 2;
		break;
	default:
		if ((sizeString.cx % 2) != 0) sizeString.cx += (2 - (sizeString.cx % 2));
		if ((sizeString.cy % 2) != 0) sizeString.cy += (2 - (sizeString.cy % 2));
		lpSize->cx = sizeString.cx >> 1;
		lpSize->cy = sizeString.cy >> 1;
	}
	// n
	SelectObject(hCanvasDC,  GetStockObject(SYSTEM_FONT));
	DeleteObject(hCanvasFont);
	DeleteDC(hCanvasDC);
	return TRUE;
//#endif
}



// LCExtTextOutiДj̎
BOOL WINAPI IMPL_ExtTextOutW(HDC hdc, int nXStart, int nYStart, UINT fuOptions, CONST RECT *lprc, LPCWSTR lpString, UINT cbString, CONST INT *lpDx)
{
	int actualX, actualY;
	UINT alignText;
	LONG canvasWidth,canvasHeight,destWidth,destHeight;
	ULONG bytesPerScanline;
	int textExtra;
	int mapMode;
	TEXTMETRIC textMetric;
	HDC hCanvasDC;
	HBITMAP hCanvasBitmap, hPrevBitmap;
	HFONT hSrcFont, hCanvasFont;
	BITMAPINFO bmpDIB;
	LOGFONT logCanvasFont;
	SIZE sizeString;
	LPBYTE lpPixels;
	int *lpNewDx = NULL;

	// Quality=0ȂoCpX
	if ((Quality == 0) || (cbString == 0)) return ORIG_ExtTextOutW(hdc, nXStart, nYStart, fuOptions, lprc, lpString, cbString, lpDx);
	
	// DC쐬
	hCanvasDC = CreateCompatibleDC(hdc);
	// }bsO[hMM_TEXTɌŒ肵čl
	mapMode = GetMapMode(hdc);
	SetMapMode(hdc, MM_TEXT);
	SetMapMode(hCanvasDC, MM_TEXT);
	// Ԃݒ肳Ă邩Ȃ̂ŐݒRs[
	textExtra = GetTextCharacterExtra(hdc);
	if (textExtra!=0x8000000) {
		switch(Quality){
		case 2:
			SetTextCharacterExtra(hCanvasDC, textExtra * 3);
			break;
		case 3:
			SetTextCharacterExtra(hCanvasDC, textExtra << 2);
			break;
		default:
			SetTextCharacterExtra(hCanvasDC, textExtra << 1);
		}
	}
	// `LOGFONT擾
	hSrcFont = (HFONT)SelectObject(hdc, GetStockObject(SYSTEM_FONT));
	GetObject(hSrcFont, sizeof(logCanvasFont), &logCanvasFont);
	SelectObject(hdc, hSrcFont);
	// 2{/3{/4{
	switch(Quality){
	case 2:
		logCanvasFont.lfHeight *=  3;
		break;
	case 3:
		logCanvasFont.lfHeight <<= 2;
		break;
	default:
		logCanvasFont.lfHeight <<= 1;
	}
	//logCanvasFont.lfWidth = 0;
	// ɕWA`GCAX𗘗piClearType𖳌
	logCanvasFont.lfQuality = ANTIALIASED_QUALITY;
	// tHg쐬đI
	hCanvasFont = CreateFontIndirect(&logCanvasFont);
	SelectObject(hCanvasDC, hCanvasFont);

	// lpDxp[^̌vZ
	if (lpDx!=0) {
		int i, dxWidth;
		ORIG_GetTextExtentPoint32W(hCanvasDC, lpString, 1, &sizeString);
		dxWidth = sizeString.cx;
		ORIG_GetTextExtentPoint32W(hCanvasDC, lpString + cbString, 1, &sizeString);
		dxWidth += sizeString.cx;
		lpNewDx = (int *)HeapAlloc(GetProcessHeap(), 0, cbString * sizeof(int));
		switch(Quality){
		case 2:
			for (i = 0; i < cbString; i++) {
				lpNewDx[i] = lpDx[i] * 3;
				dxWidth += lpNewDx[i];
			}
			break;
		case 3:
			for (i = 0; i < cbString; i++) {
				lpNewDx[i] = lpDx[i] << 2;
				dxWidth += lpNewDx[i];
			}
			break;
		default:
			for (i = 0; i < cbString; i++) {
				lpNewDx[i] = lpDx[i] << 1;
				dxWidth += lpNewDx[i];
			}
		}
		sizeString.cx = dxWidth;
	} else {
		// `悳镶̑傫擾
		ORIG_GetTextExtentPoint32W(hCanvasDC, lpString,cbString, &sizeString);
	}
	// Α̎ɑ镶l
	GetTextMetrics(hCanvasDC, &textMetric);
	sizeString.cx += textMetric.tmOverhang;

	RECT rcClip;
	LPRECT lprcClip = NULL;
	// iɉ2/3/4̔{ɂ낦
	if ((fuOptions & ETO_CLIPPED) && ( lprc != NULL )) {
		// NbsÖ悪w肳ĂƂ͂𗘗p
		destWidth = lprc->right - lprc->left;
		destHeight = lprc->bottom - lprc ->top;
		switch(Quality){
		case 2:
			canvasWidth  = destWidth * 3;
			canvasHeight = destHeight * 3;
			break;
		case 3:
			canvasWidth  = destWidth << 2;
			canvasHeight = destHeight << 2;
			break;
		default:
			canvasWidth  = destWidth << 1;
			canvasHeight = destHeight << 1;
		}
		SetRect(&rcClip, 0, 0, canvasWidth, canvasHeight);
		//lprcClip = &rcClip;
	} else {
		switch(Quality){
		case 2:
			if ((sizeString.cx % 3) != 0) sizeString.cx += (3 - (sizeString.cx % 3));
			if ((sizeString.cy % 3) != 0) sizeString.cy += (3 - (sizeString.cy % 3));
			destWidth  = sizeString.cx / 3;
			destHeight = sizeString.cy / 3;
			break;
		case 3:
			if ((sizeString.cx % 4) != 0) sizeString.cx += (4 - (sizeString.cx % 4));
			if ((sizeString.cy % 4) != 0) sizeString.cy += (4 - (sizeString.cy % 4));
			destWidth  = sizeString.cx >> 2;
			destHeight = sizeString.cy >> 2;
			break;
		default:
			if ((sizeString.cx % 2) != 0) sizeString.cx += (2 - (sizeString.cx % 2));
			if ((sizeString.cy % 2) != 0) sizeString.cy += (2 - (sizeString.cy % 2));
			destWidth  = sizeString.cx >> 1;
			destHeight = sizeString.cy >> 1;
		}
		// ʂ̃TCY
		canvasWidth = sizeString.cx;
		canvasHeight = sizeString.cy;
	}

	// s̃oCgi32bpp1sNZ=32rbg=4oCg
	bytesPerScanline = (canvasWidth << 2);
	// 32bppDIBSection쐬
	bmpDIB.bmiHeader.biSize = sizeof(bmpDIB.bmiHeader);
    bmpDIB.bmiHeader.biWidth = canvasWidth;
    bmpDIB.bmiHeader.biHeight = -canvasHeight;
    bmpDIB.bmiHeader.biPlanes = 1;
    bmpDIB.bmiHeader.biBitCount = 32;
    bmpDIB.bmiHeader.biCompression = BI_RGB;
    bmpDIB.bmiHeader.biSizeImage = bytesPerScanline * canvasHeight;
	hCanvasBitmap = (HBITMAP)CreateDIBSection(hdc, &bmpDIB, DIB_RGB_COLORS,(void **) &lpPixels, NULL, NULL);
	hPrevBitmap = (HBITMAP)SelectObject(hCanvasDC, hCanvasBitmap);

	// `GetTextAlign()̏Ԃɉē]ʒuς
	alignText = GetTextAlign(hdc);
	// ʒu
	actualX = nXStart;
	if (alignText & TA_CENTER) {
		actualX = nXStart - (destWidth >> 1);
	} else if (alignText & TA_RIGHT) {
		actualX = nXStart - destWidth;
	}
	// cʒu
	actualY = nYStart;
	switch(Quality){
	case 2:
		textMetric.tmAscent /= 3;
		textMetric.tmDescent /= 3;
		break;
	case 3:
		textMetric.tmAscent >>= 2;
		textMetric.tmDescent >>= 2;
		break;
	default:
		textMetric.tmAscent >>= 1;
		textMetric.tmDescent >>= 1;
	}
	// Firefox  TA_BOTTOM ŌĂł邯ǁAf
	//   actualY = nYStart - destHeight;
	// ƂƏɕ\ꂷĂ܂̂ŁAƂ肠̂悤ɂĂƂ݂
	if (alignText & TA_BOTTOM) {
		actualY = nYStart - textMetric.tmAscent;
		OutputDebugString(L"TA_BOTTOM");
	} else if (alignText & TA_BASELINE)  {
		actualY = nYStart - textMetric.tmAscent;
		OutputDebugString(L"TA_BASELINE");
	} else if (alignText & VTA_BASELINE) {
		actualY = nYStart - textMetric.tmAscent;
		OutputDebugString(L"VTA_BASELINE");
	} else if (alignText & VTA_CENTER) {
		actualY = nYStart - ((textMetric.tmAscent) >> 1);
		OutputDebugString(L"VTA_CENTER");
	} 

	HBRUSH hBrush;
	// wi[h̏ꍇStretchBltŔwi炩ߓ]Ă
	if (GetBkMode(hdc) == TRANSPARENT) {
		SetBkMode(hCanvasDC, TRANSPARENT);
		StretchBlt(hCanvasDC, 0, 0, canvasWidth, canvasHeight, hdc, actualX, actualY, destWidth, destHeight, SRCCOPY); 
	} else {
		SetBkMode(hCanvasDC, OPAQUE);
		SetBkColor(hCanvasDC, GetBkColor(hdc));
		// wiOPAQUEłAŔ{ɑăTCY𒲐߂ĂꍇA
		// wiFœhԂȂȂ̂ŁAhԂĂ
		hBrush = CreateSolidBrush(GetBkColor(hdc));
		RECT rcOpaque = {0, 0, canvasWidth, canvasHeight};
		FillRect(hCanvasDC, &rcOpaque, hBrush);
		DeleteObject(hBrush);
	}
	if ((fuOptions & ETO_OPAQUE) && (lprc != NULL)) {
		hBrush = CreateSolidBrush(GetBkColor(hdc));
		FillRect(hdc, lprc, hBrush);
		DeleteObject(hBrush);
	}

	// Fݒ
	SetTextColor(hCanvasDC, GetTextColor(hdc));	
	
	// zmTextOutĂ
	// Weight=0: ftHgBʂ1`B
	// Weight=1: 1sNZɂ炵2`BƔZB
	// Weight=2: c1sNZ炵Čv4`BȂZB
	switch(Weight) {
	case 2:
		ORIG_ExtTextOutW(hCanvasDC,0,0,fuOptions,lprcClip,lpString,cbString,lpNewDx);
		ORIG_ExtTextOutW(hCanvasDC,1,0,fuOptions,lprcClip,lpString,cbString,lpNewDx);
		break;
	case 3:
		ORIG_ExtTextOutW(hCanvasDC,0,0,fuOptions,lprcClip,lpString,cbString,lpNewDx);
		ORIG_ExtTextOutW(hCanvasDC,1,0,fuOptions,lprcClip,lpString,cbString,lpNewDx);
		ORIG_ExtTextOutW(hCanvasDC,0,1,fuOptions,lprcClip,lpString,cbString,lpNewDx);
		ORIG_ExtTextOutW(hCanvasDC,1,1,fuOptions,lprcClip,lpString,cbString,lpNewDx);
		break;
	default:
		ORIG_ExtTextOutW(hCanvasDC,0,0,fuOptions,lprcClip,lpString,cbString,lpNewDx);
		ORIG_ExtTextOutW(hCanvasDC,0,0,fuOptions,lprcClip,lpString,cbString,lpNewDx);
	}
	if (lpNewDx != NULL) HeapFree(GetProcessHeap(), 0, lpNewDx);
	// UseSubPixel=1: ClearTypeǂgpB
	// ԃ`lƐ`lꂼtɂ炵ĂB
	// ł́A[ƉE[̃sNZ̐FȂ\B
	// ́AUwiɕ`悵ĂA`ɃAt@uhĂȂB
	// {̂ق@Ȃ񂾂ǂAĂ܂BNL{k
	/*
	if (UseSubPixel==1) {
		// SubPixelDirection=0: TusNZRGB̏ɕłBLCD̕B
		// SubPixelDirection=1: TusNZBGȐɕłB͒LCDB
		if (SubPixelDirection==0) {
			// for(x = 4; x < (int)bmpDIB.bmiHeader.biSizeImage; x += 4) lpPixels[x - 4] = lpPixels[x];
			//for(x = bmpDIB.bmiHeader.biSizeImage - 4; x > 4; x -= 4) lpPixels[x + 2] = lpPixels[x - 2];	
		} else {
			//for(x = 4; x < (int)bmpDIB.bmiHeader.biSizeImage; x += 4) lpPixels[x - 2] = lpPixels[x + 2];
			//for(x = bmpDIB.bmiHeader.biSizeImage - 4; x > 4; x -= 4) lpPixels[x] = lpPixels[x - 4];	
		}
	}
	*/

	// k[`
	unsigned int x, y, px, py, y1, y2, y3, y4;
	px = 0;
	py = 0;
	y1 = 0;
	y2 = 0;
	y3 = 0;
	y4 = 0;
	switch(Quality) {
	case 2:
		for(y = 0; y < canvasHeight; y += 3){
			px = 0;
			y2 = y1 + bytesPerScanline;
			y3 = y2 + bytesPerScanline;
			for(x = 0; x < bytesPerScanline; x += 12){
				lpPixels[px + py + 0] = ColorTable3x[lpPixels[0 + x + y1] + lpPixels[4 + x + y1] + lpPixels[ 8 + x + y1]
											   + lpPixels[0 + x + y2] + lpPixels[4 + x + y2] + lpPixels[ 8 + x + y2]
												   + lpPixels[0 + x + y3] + lpPixels[4 + x + y3] + lpPixels[ 8 + x + y3]];
				lpPixels[px + py + 1] = ColorTable3x[lpPixels[1 + x + y1] + lpPixels[5 + x + y1] + lpPixels[ 9 + x + y1]
												   + lpPixels[1 + x + y2] + lpPixels[5 + x + y2] + lpPixels[ 9 + x + y2]
												   + lpPixels[1 + x + y3] + lpPixels[5 + x + y3] + lpPixels[ 9 + x + y3]];
				lpPixels[px + py + 2] = ColorTable3x[lpPixels[2 + x + y1] + lpPixels[6 + x + y1] + lpPixels[10 + x + y1]
												   + lpPixels[2 + x + y2] + lpPixels[6 + x + y2] + lpPixels[10 + x + y2]
												   + lpPixels[2 + x + y3] + lpPixels[6 + x + y3] + lpPixels[10 + x + y3]];
				px += 4;
			}
			py += bytesPerScanline;
			y1 = y3 + bytesPerScanline;
		}
		break;
	case 3:
		for(y = 0; y < canvasHeight; y += 4){
			px = 0;
			y2 = y1 + bytesPerScanline;
			y3 = y2 + bytesPerScanline;
			y4 = y3 + bytesPerScanline;
			for(x = 0; x < bytesPerScanline; x += 16){
				lpPixels[px + py + 0] = (lpPixels[0 + x + y1] + lpPixels[4 + x + y1] + lpPixels[ 8 + x + y1] + lpPixels[12 + x + y1]
									   + lpPixels[0 + x + y2] + lpPixels[4 + x + y2] + lpPixels[ 8 + x + y2] + lpPixels[12 + x + y2]
									   + lpPixels[0 + x + y3] + lpPixels[4 + x + y3] + lpPixels[ 8 + x + y3] + lpPixels[12 + x + y3]
									   + lpPixels[0 + x + y4] + lpPixels[4 + x + y4] + lpPixels[ 8 + x + y4] + lpPixels[12 + x + y4]) >> 4;
				lpPixels[px + py + 1] = (lpPixels[1 + x + y1] + lpPixels[5 + x + y1] + lpPixels[ 9 + x + y1] + lpPixels[13 + x + y1]
									   + lpPixels[1 + x + y2] + lpPixels[5 + x + y2] + lpPixels[ 9 + x + y2] + lpPixels[13 + x + y2]
									   + lpPixels[1 + x + y3] + lpPixels[5 + x + y3] + lpPixels[ 9 + x + y3] + lpPixels[13 + x + y3]
									   + lpPixels[1 + x + y4] + lpPixels[5 + x + y4] + lpPixels[ 9 + x + y4] + lpPixels[13 + x + y4]) >> 4;
				lpPixels[px + py + 2] = (lpPixels[2 + x + y1] + lpPixels[6 + x + y1] + lpPixels[10 + x + y1] + lpPixels[14 + x + y1]
									   + lpPixels[2 + x + y2] + lpPixels[6 + x + y2] + lpPixels[10 + x + y2] + lpPixels[14 + x + y2]
									   + lpPixels[2 + x + y3] + lpPixels[6 + x + y3] + lpPixels[10 + x + y3] + lpPixels[14 + x + y3]
									   + lpPixels[2 + x + y4] + lpPixels[6 + x + y4] + lpPixels[10 + x + y4] + lpPixels[14 + x + y4]) >> 4;
				px += 4;
			}
			py += bytesPerScanline;
			y1 = y4 + bytesPerScanline;
		}
		break;
	default:
		for(y = 0; y < canvasHeight; y += 2){
			px = 0;
			y2 = y1 + bytesPerScanline;
			for(x = 0; x < bytesPerScanline; x += 8){
				lpPixels[px + py + 0] = (lpPixels[0 + x + y1] + lpPixels[4 + x + y1]
									   + lpPixels[0 + x + y2] + lpPixels[4 + x + y2]) >> 2;
				lpPixels[px + py + 1] = (lpPixels[1 + x + y1] + lpPixels[5 + x + y1]
									   + lpPixels[1 + x + y2] + lpPixels[5 + x + y2]) >> 2;
				lpPixels[px + py + 2] = (lpPixels[2 + x + y1] + lpPixels[6 + x + y1]
									   + lpPixels[2 + x + y2] + lpPixels[6 + x + y2]) >> 2;
				px += 4;
			}
			py += bytesPerScanline;
			y1 = y2 + bytesPerScanline;
		}
	}

	// ]
	BitBlt(hdc,actualX,actualY,destWidth,destHeight,hCanvasDC,0,0,SRCCOPY);
	// n
	SelectObject(hCanvasDC,  GetStockObject(SYSTEM_FONT));
	SelectObject(hCanvasDC, hPrevBitmap);
	DeleteObject(hCanvasFont);
	DeleteObject(hCanvasBitmap);
	DeleteDC(hCanvasDC);
	SetMapMode(hdc, mapMode);
	return TRUE;
}

//EOF
